﻿/*
Transposition AS3 d'un code de Jean-Louis Gaujal
*/
package {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;

	public class Colliner extends Sprite {
		private var nombre:Number;
		public function Colliner() {
			//sécurité pour être sûr que le stage a été ajouter sur le stag
			addEventListener(Event.ADDED_TO_STAGE,added_handler);
		}
		private function added_handler(e:Event):void {
			stage.addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		}
		private function down_handler(e:MouseEvent):void {
			if ( nombre != 0 ) {
				for (var i:Number=0; i<nombre; i++) {
					var col:DisplayObject = getChildByName("collin"+i);
					removeChild(col);
				}
			}
			nombre = 0;
			stage.addEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		}
		private function up_handler(e:MouseEvent):void {
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		}
		private function move_handler(e:MouseEvent):void {
			var collin:Collin = new Collin();
			collin.name = "collin" + nombre;
			collin.x = mouseX;
			collin.y = mouseY;
			collin.long = 0;
			collin.angle = 0;
			var couleur:uint =Math.random()*0xffffff;
			var taille:Number =Math.random()*5;
			collin.graphics.lineStyle(taille,0xffffff,1);
			collin.addEventListener(Event.ENTER_FRAME,enter_handler);
			addChild(collin);
			nombre++;
		}
		private function enter_handler(e:Event):void {
			e.currentTarget.angle +=.35;
			//calcul pour l'onde
			e.currentTarget.posx = 25 * (Math.cos(0.003 *e.currentTarget.long*e.currentTarget.angle - (e.currentTarget.x/30) - Math.sin(e.currentTarget.long/30)));
			if (e.currentTarget.long > stage.stageHeight) {
				e.currentTarget.graphics.drawCircle(10,10,100);
				var myTweenX:Tween = new Tween(e.currentTarget, "x", Strong.easeOut, e.currentTarget.x , 300, 3, true);
				


			} else {
				e.currentTarget.graphics.drawCircle(10,10,100);
				var myTweenXbis:Tween = new Tween(e.currentTarget, "y", Strong.easeOut, e.currentTarget.y , 300, 3, true);
				


			}
			e.currentTarget.long+=7;


		}
	}
}
import flash.display.Sprite;
class Collin extends Sprite {
	public var long:Number;
	public var angle:Number;
	public var posx:Number;
	function Collin() {
	}
}